/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.db_service.DbService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import java.awt.event.ActionEvent;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author hapallen
 */
public class ConnectDbJDialog extends EditJdialog {

    private javax.swing.JButton connectButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel connectionUrlLabel;
    private javax.swing.JLabel usernameLabel;
    private javax.swing.JLabel passwordLabel;
    private javax.swing.JTextField connectionUrlTextField;
    private javax.swing.JTextField usernameTextField;
    private javax.swing.JTextField passwordTextField;

    public ConnectDbJDialog(RychlyBalikGui parent, boolean modal, RychlyBalikDataService dataModel) {
        super(parent, modal, dataModel);
    }

    protected void createGui() {

        connectionUrlTextField = new javax.swing.JTextField();
        connectionUrlLabel = new javax.swing.JLabel();
        usernameLabel = new javax.swing.JLabel();
        usernameTextField = new javax.swing.JTextField();
        passwordLabel = new javax.swing.JLabel();
        passwordTextField = new javax.swing.JTextField();
        connectButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        connectionUrlLabel.setText("URL databáze:");

        usernameLabel.setText("Přihlašovací jméno:");

        passwordLabel.setText("Přihlašovací jméno:");

        connectButton.setText("Připojit");
        connectButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                save(evt);
            }
        });

        cancelButton.setText("Zrušit");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel(evt);
            }
        });

        javax.swing.GroupLayout layout =
                new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addGap(41, 41, 41).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING).
                addComponent(connectButton).addComponent(passwordLabel).
                addComponent(usernameLabel).addComponent(connectionUrlLabel)).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addComponent(connectionUrlTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 234, javax.swing.GroupLayout.PREFERRED_SIZE).
                addComponent(usernameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE).
                addComponent(passwordTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))).
                addGroup(layout.createSequentialGroup().addGap(50, 50, 50).
                addComponent(cancelButton))).addContainerGap(38, Short.MAX_VALUE)));
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addGap(25, 25, 25).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(connectionUrlTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).
                addComponent(connectionUrlLabel)).addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(usernameLabel).addComponent(usernameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).
                addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(passwordLabel).addComponent(passwordTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).
                addGap(18, 18, 18).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(connectButton).addComponent(cancelButton)).
                addContainerGap(12, Short.MAX_VALUE)));
        DbService dbService = dataModel.getDbService();
        connectionUrlTextField.setText(dbService.getUrl());
        usernameTextField.setText(dbService.getUser());
        passwordTextField.setText(dbService.getPassword());
        pack();
    }

    @Override
    protected void saveToObject(ActionEvent evt) throws RychlyBalikException {

        DbService dbService = dataModel.getDbService();
        dbService.setUrl(connectionUrlTextField.getText());
        dbService.setUser(usernameTextField.getText());
        dbService.setPassword(passwordTextField.getText());

        try {
            dbService.getConnection();
            dataModel.loadData();
            this.parentGui.setIsConnectedToDB(true);
            this.parentGui.aktualizujGui();
        } catch (Exception e) {
            Logger.getLogger(ConnectDbJDialog.class.getName()).
                    log(Level.SEVERE, null, e);
            System.out.println(e);
            throw new RychlyBalikException("Nastaly potize pri pokusu pripojit se k DB; " + e.
                    getMessage());
        }

    }
}

