/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 *
 * @author hapallen
 */
public abstract class EditJdialog extends JDialog {

    RychlyBalikDataService dataModel;
    RychlyBalikGui parentGui;

    public EditJdialog(RychlyBalikGui parent, boolean modal, RychlyBalikDataService dataModel) {
        super(parent, modal);
        this.dataModel = dataModel;
        this.parentGui = (RychlyBalikGui) parent;
        createGui();
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    }

    abstract protected void createGui();

    /**
     * univerzalni save, ktery odchyti vyjimky a zobrazi je
     * @param evt
     */
    protected void save(java.awt.event.ActionEvent evt) {
        try {
            saveToObject(evt);
            this.dispose();
        } catch (RychlyBalikException re) {
            JOptionPane.showMessageDialog(null,
                    "Nastala chyba pri ukladani objektu: " + re.getMessage(), "Chyba ukladani objektu", JOptionPane.ERROR_MESSAGE);
        }
    }

    abstract protected void saveToObject(java.awt.event.ActionEvent evt) throws RychlyBalikException;

    protected void cancel(java.awt.event.ActionEvent evt) {
        this.dispose();
    }
}
