/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui.table_models;

import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hapallen
 */
public class SmenaTableModel extends AbstractTableModel {

    List<Pracovnik> pracovnici;

    public SmenaTableModel(List<Pracovnik> pracovnici) {
        super();
        this.pracovnici = pracovnici;
    }

    @Override
    public String getColumnName(int col) {
        return Pracovnik.getDescriptor()[col];
    }

    public int getRowCount() {
        return pracovnici.size();
    }

    public int getColumnCount() {
        return Pracovnik.getDescriptor().length;
    }

    public Object getValueAt(int row, int col) {
        Pracovnik pracovnik = pracovnici.get(row);
        return pracovnik.getAsMap().get(Pracovnik.getDescriptor()[col]);
    }

    public Pracovnik getValueAtRow(int row) {
        return pracovnici.get(row);
    }
}


