/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui.table_models;

import a0b36pr2_du2.rychly_balik.model.Zasilka;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hapallen
 */
public class ZasilkyTableModel extends AbstractTableModel {

    List<Zasilka> zasilky;

    public ZasilkyTableModel(List<Zasilka> zasilky) {
        super();
        this.zasilky = zasilky;
    }

    @Override
    public String getColumnName(int col) {
        return Zasilka.getDescriptor()[col];
    }

    public int getRowCount() {
        return zasilky.size();
    }

    public int getColumnCount() {
        return Zasilka.getDescriptor().length;
    }

    public Object getValueAt(int row, int col) {
        Zasilka zasilka = zasilky.get(row);
        return zasilka.getAsMap().get(Zasilka.getDescriptor()[col]);
    }

    public Zasilka getValueAtRow(int row) {
        return zasilky.get(row);
    }
}

