/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model.doprava;

import java.util.HashMap;
import java.util.Map;

/**
 * Dodávka velká, která po Praze jezdí rychlostí 40 km/hod, uveze zásilky do
 * hmotnost 4tuny (nosnost) a cena za dopravu vznikne jako paušál za použití
 * ve výši 50Kč a ceny za kilometr, která obsahuje cenu řidiče,
 * PHM a všechny další náklady a tato cena je 250Kč/hod.
 * Pro řízení tohoto vozidla je požadováno řidičské oprávnění skupiny B.
 * @author hapallen
 */
public class Dodavka extends Doprava implements Riditelny {

    public static final double RYCHLOST = 40; // RYCHLOST km/hod
    public static final double NOSNOST = 4000;

    public double getNosnost() {
        return NOSNOST; // nosnost v kg
    }

    public double getCenaZaVzdalenost(double vzdalenost) {
        return 50 + 250 * (vzdalenost / RYCHLOST);
    }

    public Opravneni getOpravneni() {
        return Opravneni.C;
    }

    public void setOpravneni(Opravneni opravneni) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String toString() {
        return String.format(TO_STRING_FORMAT, getTypDopravy().name(), getNosnost(), RYCHLOST, getCenaZaVzdalenost(1));
    }

    @Override
    public TypDopravy getTypDopravy() {
        return TypDopravy.DODAVKA;
    }

    @Override
    public double getRychlost() {
        return RYCHLOST;
    }
}
