/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui.table_models;

import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author hapallen
 */
public class DopravaTableModel extends AbstractTableModel {

    List<Doprava> dopravniProstredky;

    public DopravaTableModel(List<Doprava> pracovnici) {
        super();
        this.dopravniProstredky = pracovnici;
    }

    @Override
    public String getColumnName(int col) {
        return Doprava.getDescriptor()[col];
    }

    public int getRowCount() {
        return dopravniProstredky.size();
    }

    public int getColumnCount() {
        return Doprava.getDescriptor().length;
    }

    public Object getValueAt(int row, int col) {
        Doprava doprava = dopravniProstredky.get(row);
        return doprava.getAsMap().get(Doprava.getDescriptor()[col]);
    }

    public Doprava getValueAtRow(int row) {
        return dopravniProstredky.get(row);
    }
}
